<?php
/*
   Plugin Name: Wooshark dropshipping for aliexpress and woocommerce
   Plugin URI: http://wordpress.org/extend/plugins/wooshark-aliexpress-importer/
   Version: 3.1.3
   Author: wooproductimporter
   Description: Wooshark dropshipping for aliexpress and woocommerce
   Text Domain: wooshark-aliexpress-importer
   License: GPLv3
  */

/*
    "WordPress Plugin Template" Copyright (C) 2018 Michael Simpson  (email : michael.d.simpson@gmail.com)

    This following part of this file is part of WordPress Plugin Template for WordPress.

    WordPress Plugin Template is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    WordPress Plugin Template is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Contact Form to Database Extension.
    If not, see http://www.gnu.org/licenses/gpl-3.0.html
*/

$WoosharkAliexpressImporter_minimalRequiredPhpVersion = '5.0';

/**
 * Check the PHP version and give a useful error message if the user's version is less than the required version
 * @return boolean true if version check passed. If false, triggers an error which WP will handle, by displaying
 * an error message on the Admin page
 */
function WoosharkAliexpressImporter_noticePhpVersionWrong()
{
    global $WoosharkAliexpressImporter_minimalRequiredPhpVersion;
    echo '<div class="updated fade">' .
        __('Error: plugin "Wooshark dropshipping for aliexpress and woocommerce" requires a newer version of PHP to be running.',  'wooshark-aliexpress-importer') .
        '<br/>' . __('Minimal version of PHP required: ', 'wooshark-aliexpress-importer') . '<strong>' . $WoosharkAliexpressImporter_minimalRequiredPhpVersion . '</strong>' .
        '<br/>' . __('Your server\'s PHP version: ', 'wooshark-aliexpress-importer') . '<strong>' . phpversion() . '</strong>' .
        '</div>';
}


function WoosharkAliexpressImporter_PhpVersionCheck()
{
    global $WoosharkAliexpressImporter_minimalRequiredPhpVersion;
    if (version_compare(phpversion(), $WoosharkAliexpressImporter_minimalRequiredPhpVersion) < 0) {
        add_action('admin_notices', 'WoosharkAliexpressImporter_noticePhpVersionWrong');
        return false;
    }
    return true;
}


/**
 * Initialize internationalization (i18n) for this plugin.
 * References:
 *      http://codex.wordpress.org/I18n_for_WordPress_Developers
 *      http://www.wdmac.com/how-to-create-a-po-language-translation#more-631
 * @return void
 */
function WoosharkAliexpressImporter_i18n_init()
{
    $pluginDir = dirname(plugin_basename(__FILE__));
    load_plugin_textdomain('wooshark-aliexpress-importer', false, $pluginDir . '/languages/');
}




//////////////////////////////////
// Run initialization
/////////////////////////////////

// Initialize i18n
// add_action('plugins_loadedi','WoosharkAliexpressImporter_i18n_init');

function my_admin_scripts_init($hook_suffix)
{




    if ('post.php' == $hook_suffix || 'post-new.php' == $hook_suffix) {

        // add_action('wp_enqueue_scripts', 'jquery_add_to_contact');
        // wp_enqueue_script('bootstrap', plugin_dir_url(__FILE__) . 'js/bootstrap.min.js', array('jquery'), NULL, false);
        wp_enqueue_style('bootstrapCss', plugin_dir_url(__FILE__) . 'css/bootstrap.min.css');
        wp_enqueue_script('originalPro', plugin_dir_url(__FILE__) . 'js/originalPro.js', array('jquery'), NULL, false);
        wp_localize_script(
            'originalPro',
            'wooshark_params',
            array(
                'ajaxurl' => admin_url('admin-ajax.php'),
                'nonce' => wp_create_nonce('ajax-nonce')
            )
        );
    }
}
add_action('admin_enqueue_scripts', 'my_admin_scripts_init');






// Run the version check.
// If it is successful, continue with initialization for this plugin
if (WoosharkAliexpressImporter_PhpVersionCheck()) {
    // Only load and run the init function if we know PHP version can parse it
    include_once('wooshark-aliexpress-importer_init.php');
    WoosharkAliexpressImporter_init(__FILE__);
    initOriginalProductUrl();
}



function initOriginalProductUrl()
{
    add_action('post_submitbox_misc_actions', 'woo_add_custom_general_fields_originalProductUrl', 20);
    function woo_add_custom_general_fields_originalProductUrl()
    {
        echo ' 
        <button type="button" style="margin:10px; "  class="btn btn-primary" id="openOriginalProductUrl" data-target=".bd-example-modal-lg"> Open Original product url (wooshark)</button>
        <div class="loader2" style="display:none"><div></div><div></div><div></div><div></div></div>';
    }
}


if (get_option(base64_decode('aXNTaGlwcGluZ0Nvc3RFbmFibGVk')) == base64_decode('WQ==')) {
    function shipping_method_ePacket()
    {
        if (!class_exists(base64_decode('V0NfWW91cl9TaGlwcGluZ19NZXRob2RfRVBBQ0tFVA=='))) {
            class WC_Your_Shipping_Method_EPACKET extends WC_Shipping_Method
            {
                /**
                 * Constructor for your shipping class
                 *
                 * @access public
                 * @return void
                 */ public function __construct()
                {
                    $this->id = base64_decode('ZXBhY2tldF9yYXRl');
                    $this->method_title = __(base64_decode('ZVBhY2tldCBTaGlwcGluZw=='));
                    $this->method_description = __(base64_decode('ZVBhY2tldCBmbGF0ZQ=='));
                    $this->title = base64_decode('ZVBhY2tldCBTaGlwcGluZw==');
                    $this->init();
                }
                /**
                 * Init your settings
                 *
                 * @access public
                 * @return void
                 */ function init()
                {
                    $this->init_form_fields();
                    $this->init_settings();
                    add_action(base64_decode('d29vY29tbWVyY2VfdXBkYXRlX29wdGlvbnNfc2hpcHBpbmdf') . $this->id, array($this, base64_decode('cHJvY2Vzc19hZG1pbl9vcHRpb25z')));
                }
                /**
                 * calculate_shipping function.
                 *
                 * @access public
                 * @param mixed $package
                 * @return void
                 */ public function calculate_shipping($package = array())
                {
                    $cost = base64_decode('MA==');
                    $rate = array(base64_decode('aWQ=') => $this->id, base64_decode('bGFiZWw=') => $this->title, base64_decode('Y29zdA==') => $cost);
                    $this->add_rate($rate);
                }
            }
        }
    }
    add_action(base64_decode('d29vY29tbWVyY2Vfc2hpcHBpbmdfaW5pdA=='), base64_decode('c2hpcHBpbmdfbWV0aG9kX2VQYWNrZXQ='));
    function add_your_shipping_method_ePacket($methods)
    {
        $methods[] = base64_decode('V0NfWW91cl9TaGlwcGluZ19NZXRob2RfRVBBQ0tFVA==');
        return $methods;
    }
    add_filter(base64_decode('d29vY29tbWVyY2Vfc2hpcHBpbmdfbWV0aG9kcw=='), base64_decode('YWRkX3lvdXJfc2hpcHBpbmdfbWV0aG9kX2VQYWNrZXQ='));
    function shipping_method_Aliexpress_standard_shipping()
    {
        if (!class_exists(base64_decode('V0NfWW91cl9TaGlwcGluZ19NZXRob2RfQWxpZXhwcmVzc19zdGFuZGFyZF9zaGlwcGluZw=='))) {
            class WC_Your_Shipping_Method_Aliexpress_standard_shipping extends WC_Shipping_Method
            {
                /**
                 * Constructor for your shipping class
                 *
                 * @access public
                 * @return void
                 */ public function __construct()
                {
                    $this->id = base64_decode('YWxpZXhwcmVzc19zdGFuZGFyZF9zaGlwcGluZw==');
                    $this->method_title = __(base64_decode('U3RhbmRhcmQgc3RhbmRhcmQgUmF0ZQ=='));
                    $this->method_description = __(base64_decode('U3RhbmRhcmQgc3RhbmRhcmQgUmF0ZQ=='));
                    $this->title = base64_decode('U3RhbmRhcmQgc3RhbmRhcmQgU2hpcHBpbmc=');
                    $this->init();
                }
                /**
                 * Init your settings
                 *
                 * @access public
                 * @return void
                 */ function init()
                {
                    $this->init_form_fields();
                    $this->init_settings();
                    add_action(base64_decode('d29vY29tbWVyY2VfdXBkYXRlX29wdGlvbnNfc2hpcHBpbmdf') . $this->id, array($this, base64_decode('cHJvY2Vzc19hZG1pbl9vcHRpb25z')));
                }
                /**
                 * calculate_shipping function.
                 *
                 * @access public
                 * @param mixed $package
                 * @return void
                 */ public function calculate_shipping($package = array())
                {
                    $cost = base64_decode('MA==');
                    $rate = array(base64_decode('aWQ=') => $this->id, base64_decode('bGFiZWw=') => $this->title, base64_decode('Y29zdA==') => $cost);
                    $this->add_rate($rate);
                }
            }
        }
    }
    add_action(base64_decode('d29vY29tbWVyY2Vfc2hpcHBpbmdfaW5pdA=='), base64_decode('c2hpcHBpbmdfbWV0aG9kX0FsaWV4cHJlc3Nfc3RhbmRhcmRfc2hpcHBpbmc='));
    function add_your_shipping_method_Aliexpress_standard_shipping($methods)
    {
        $methods[] = base64_decode('V0NfWW91cl9TaGlwcGluZ19NZXRob2RfQWxpZXhwcmVzc19zdGFuZGFyZF9zaGlwcGluZw==');
        return $methods;
    }
    add_filter(base64_decode('d29vY29tbWVyY2Vfc2hpcHBpbmdfbWV0aG9kcw=='), base64_decode('YWRkX3lvdXJfc2hpcHBpbmdfbWV0aG9kX0FsaWV4cHJlc3Nfc3RhbmRhcmRfc2hpcHBpbmc='));
    function shipping_method_FEDEX_SHIPPING()
    {
        if (!class_exists(base64_decode('V0NfWW91cl9TaGlwcGluZ19NZXRob2RfRkVERVhfU0hJUFBJTkc='))) {
            class WC_Your_Shipping_Method_FEDEX_SHIPPING extends WC_Shipping_Method
            {
                /**
                 * Constructor for your shipping class
                 *
                 * @access public
                 * @return void
                 */ public function __construct()
                {
                    $this->id = base64_decode('ZmVkZXhfc2hpcHBpbmc=');
                    $this->method_title = __(base64_decode('RmVkZXggc2hpcHBpbmc='));
                    $this->method_description = __(base64_decode('RmVkZXggc2hpcHBpbmc='));
                    $this->title = base64_decode('RmVkZXggU2hpcHBpbmc=');
                    $this->init();
                }
                /**
                 * Init your settings
                 *
                 * @access public
                 * @return void
                 */ function init()
                {
                    $this->init_form_fields();
                    $this->init_settings();
                    add_action(base64_decode('d29vY29tbWVyY2VfdXBkYXRlX29wdGlvbnNfc2hpcHBpbmdf') . $this->id, array($this, base64_decode('cHJvY2Vzc19hZG1pbl9vcHRpb25z')));
                }
                /**
                 * calculate_shipping function.
                 *
                 * @access public
                 * @param mixed $package
                 * @return void
                 */ public function calculate_shipping($package = array())
                {
                    $cost = base64_decode('MA==');
                    $rate = array(base64_decode('aWQ=') => $this->id, base64_decode('bGFiZWw=') => $this->title, base64_decode('Y29zdA==') => $cost);
                    $this->add_rate($rate);
                }
            }
        }
    }
    add_action(base64_decode('d29vY29tbWVyY2Vfc2hpcHBpbmdfaW5pdA=='), base64_decode('c2hpcHBpbmdfbWV0aG9kX0ZFREVYX1NISVBQSU5H'));
    function add_your_shipping_method_FEDEX_SHIPPING($methods)
    {
        $methods[] = base64_decode('V0NfWW91cl9TaGlwcGluZ19NZXRob2RfRkVERVhfU0hJUFBJTkc=');
        return $methods;
    }
    add_filter(base64_decode('d29vY29tbWVyY2Vfc2hpcHBpbmdfbWV0aG9kcw=='), base64_decode('YWRkX3lvdXJfc2hpcHBpbmdfbWV0aG9kX0ZFREVYX1NISVBQSU5H'));
    function shipping_method_DHL()
    {
        if (!class_exists(base64_decode('V0NfWW91cl9TaGlwcGluZ19NZXRob2RfREhM'))) {
            class WC_Your_Shipping_Method_DHL extends WC_Shipping_Method
            {
                /**
                 * Constructor for your shipping class
                 *
                 * @access public
                 * @return void
                 */ public function __construct()
                {
                    $this->id = base64_decode('ZGhsX3NoaXBwaW5n');
                    $this->method_title = __(base64_decode('REhMIFNoaXBwaW5n'));
                    $this->method_description = __(base64_decode('REhMIHNoaXBwaW5n'));
                    $this->title = base64_decode('REhMIFNoaXBwaW5n');
                    $this->init();
                }
                /**
                 * Init your settings
                 *
                 * @access public
                 * @return void
                 */ function init()
                {
                    $this->init_form_fields();
                    $this->init_settings();
                    add_action(base64_decode('d29vY29tbWVyY2VfdXBkYXRlX29wdGlvbnNfc2hpcHBpbmdf') . $this->id, array($this, base64_decode('cHJvY2Vzc19hZG1pbl9vcHRpb25z')));
                }
                /**
                 * calculate_shipping function.
                 *
                 * @access public
                 * @param mixed $package
                 * @return void
                 */ public function calculate_shipping($package = array())
                {
                    $cost = base64_decode('MA==');
                    $rate = array(base64_decode('aWQ=') => $this->id, base64_decode('bGFiZWw=') => $this->title, base64_decode('Y29zdA==') => $cost);
                    $this->add_rate($rate);
                }
            }
        }
    }
    add_action(base64_decode('d29vY29tbWVyY2Vfc2hpcHBpbmdfaW5pdA=='), base64_decode('c2hpcHBpbmdfbWV0aG9kX0RITA=='));
    function add_your_shipping_method_DHL($methods)
    {
        $methods[] = base64_decode('V0NfWW91cl9TaGlwcGluZ19NZXRob2RfREhM');
        return $methods;
    }
    add_filter(base64_decode('d29vY29tbWVyY2Vfc2hpcHBpbmdfbWV0aG9kcw=='), base64_decode('YWRkX3lvdXJfc2hpcHBpbmdfbWV0aG9kX0RITA=='));
    function shipping_method_Aliexpress_premuim_shipping()
    {
        if (!class_exists(base64_decode('V0NfWW91cl9TaGlwcGluZ19NZXRob2RfQWxpZXhwcmVzc19wcmVtdWltX3NoaXBwaW5n'))) {
            class WC_Your_Shipping_Method_Aliexpress_premuim_shipping extends WC_Shipping_Method
            {
                /**
                 * Constructor for your shipping class
                 *
                 * @access public
                 * @return void
                 */ public function __construct()
                {
                    $this->id = base64_decode('cHJlbXVpbV9zaGlwcGluZw==');
                    $this->method_title = __(base64_decode('UHJlbXVpbSBTaGlwcGluZw=='));
                    $this->method_description = __(base64_decode('UHJlbXVpbSBzaGlwcGluZw=='));
                    $this->title = base64_decode('UHJlbXVpbSBTaGlwcGluZw==');
                    $this->init();
                }
                /**
                 * Init your settings
                 *
                 * @access public
                 * @return void
                 */ function init()
                {
                    $this->init_form_fields();
                    $this->init_settings();
                    add_action(base64_decode('d29vY29tbWVyY2VfdXBkYXRlX29wdGlvbnNfc2hpcHBpbmdf') . $this->id, array($this, base64_decode('cHJvY2Vzc19hZG1pbl9vcHRpb25z')));
                }
                /**
                 * calculate_shipping function.
                 *
                 * @access public
                 * @param mixed $package
                 * @return void
                 */ public function calculate_shipping($package = array())
                {
                    $cost = base64_decode('MA==');
                    $rate = array(base64_decode('aWQ=') => $this->id, base64_decode('bGFiZWw=') => $this->title, base64_decode('Y29zdA==') => $cost);
                    $this->add_rate($rate);
                }
            }
        }
    }
    add_action(base64_decode('d29vY29tbWVyY2Vfc2hpcHBpbmdfaW5pdA=='), base64_decode('c2hpcHBpbmdfbWV0aG9kX0FsaWV4cHJlc3NfcHJlbXVpbV9zaGlwcGluZw=='));
    function add_your_shipping_method_Aliexpress_premuim_shipping($methods)
    {
        $methods[] = base64_decode('V0NfWW91cl9TaGlwcGluZ19NZXRob2RfQWxpZXhwcmVzc19wcmVtdWltX3NoaXBwaW5n');
        return $methods;
    }
    add_filter(base64_decode('d29vY29tbWVyY2Vfc2hpcHBpbmdfbWV0aG9kcw=='), base64_decode('YWRkX3lvdXJfc2hpcHBpbmdfbWV0aG9kX0FsaWV4cHJlc3NfcHJlbXVpbV9zaGlwcGluZw=='));
    function shipping_method_EMS_SHIPPING()
    {
        if (!class_exists(base64_decode('V0NfWW91cl9TaGlwcGluZ19NZXRob2RfRU1TX1NISVBQSU5H'))) {
            class WC_Your_Shipping_Method_EMS_SHIPPING extends WC_Shipping_Method
            {
                /**
                 * Constructor for your shipping class
                 *
                 * @access public
                 * @return void
                 */ public function __construct()
                {
                    $this->id = base64_decode('ZW1zX3NoaXBwaW5n');
                    $this->method_title = __(base64_decode('RW1zIFNoaXBwaW5n'));
                    $this->method_description = __(base64_decode('RW1zIHNoaXBwaW5n'));
                    $this->title = base64_decode('RW1zIHNoaXBwaW5n');
                    $this->init();
                }
                /**
                 * Init your settings
                 *
                 * @access public
                 * @return void
                 */ function init()
                {
                    $this->init_form_fields();
                    $this->init_settings();
                    add_action(base64_decode('d29vY29tbWVyY2VfdXBkYXRlX29wdGlvbnNfc2hpcHBpbmdf') . $this->id, array($this, base64_decode('cHJvY2Vzc19hZG1pbl9vcHRpb25z')));
                }
                /**
                 * calculate_shipping function.
                 *
                 * @access public
                 * @param mixed $package
                 * @return void
                 */ public function calculate_shipping($package = array())
                {
                    $cost = base64_decode('MA==');
                    $rate = array(base64_decode('aWQ=') => $this->id, base64_decode('bGFiZWw=') => $this->title, base64_decode('Y29zdA==') => $cost);
                    $this->add_rate($rate);
                }
            }
        }
    }
    add_action(base64_decode('d29vY29tbWVyY2Vfc2hpcHBpbmdfaW5pdA=='), base64_decode('c2hpcHBpbmdfbWV0aG9kX0VNU19TSElQUElORw=='));
    function add_your_shipping_method_EMS_SHIPPING($methods)
    {
        $methods[] = base64_decode('V0NfWW91cl9TaGlwcGluZ19NZXRob2RfRU1TX1NISVBQSU5H');
        return $methods;
    }
    add_filter(base64_decode('d29vY29tbWVyY2Vfc2hpcHBpbmdfbWV0aG9kcw=='), base64_decode('YWRkX3lvdXJfc2hpcHBpbmdfbWV0aG9kX0VNU19TSElQUElORw=='));
    function shipping_method_Cainiao()
    {
        if (!class_exists(base64_decode('V0NfWW91cl9TaGlwcGluZ19NZXRob2RfQ2Fpbmlhbw=='))) {
            class WC_Your_Shipping_Method_Cainiao extends WC_Shipping_Method
            {
                /**
                 * Constructor for your shipping class
                 *
                 * @access public
                 * @return void
                 */ public function __construct()
                {
                    $this->id = base64_decode('Y2Fpbmlhb19zaGlwcGluZw==');
                    $this->method_title = __(base64_decode('U3VwZXIgRWNvbm9teSBHbG9iYWw='));
                    $this->method_description = __(base64_decode('U3VwZXIgRWNvbm9teSBHbG9iYWw='));
                    $this->title = base64_decode('U3VwZXIgRWNvbm9teSBHbG9iYWw=');
                    $this->init();
                }
                /**
                 * Init your settings
                 *
                 * @access public
                 * @return void
                 */ function init()
                {
                    $this->init_form_fields();
                    $this->init_settings();
                    add_action(base64_decode('d29vY29tbWVyY2VfdXBkYXRlX29wdGlvbnNfc2hpcHBpbmdf') . $this->id, array($this, base64_decode('cHJvY2Vzc19hZG1pbl9vcHRpb25z')));
                }
                /**
                 * calculate_shipping function.
                 *
                 * @access public
                 * @param mixed $package
                 * @return void
                 */ public function calculate_shipping($package = array())
                {
                    $cost = base64_decode('MA==');
                    $rate = array(base64_decode('aWQ=') => $this->id, base64_decode('bGFiZWw=') => $this->title, base64_decode('Y29zdA==') => $cost);
                    $this->add_rate($rate);
                }
            }
        }
    }
    add_action(base64_decode('d29vY29tbWVyY2Vfc2hpcHBpbmdfaW5pdA=='), base64_decode('c2hpcHBpbmdfbWV0aG9kX0NhaW5pYW8='));
    function add_your_shipping_method_Cainiao($methods)
    {
        $methods[] = base64_decode('V0NfWW91cl9TaGlwcGluZ19NZXRob2RfQ2Fpbmlhbw==');
        return $methods;
    }
    add_filter(base64_decode('d29vY29tbWVyY2Vfc2hpcHBpbmdfbWV0aG9kcw=='), base64_decode('YWRkX3lvdXJfc2hpcHBpbmdfbWV0aG9kX0NhaW5pYW8='));
    add_filter(base64_decode('d29vY29tbWVyY2VfcGFja2FnZV9yYXRlcw=='), base64_decode('Y3VzdG9tX3NoaXBwaW5nX2Nvc3Rz'), 20, 2);
    function custom_shipping_costs($rates, $package)
    {
        $pp = $package[base64_decode('ZGVzdGluYXRpb24=')][base64_decode('Y291bnRyeQ==')];
        $tt = WC()->cart->get_cart_contents_count();
        foreach ($package[base64_decode('Y29udGVudHM=')] as $item_id => $values) {
            $pr = $values[base64_decode('ZGF0YQ==')];
            $p = wc_get_product($pr->get_parent_id());
            $pu = get_post_meta($pr->get_parent_id(), base64_decode('cHJvZHVjdFVybA=='), true);
            if (isset($pu) && strpos($pu, base64_decode('YWxpZXhwcmVzcy5jb20=')) !== false) {
                $ss = $p->get_sku();
                $curl = curl_init();
                $finalUrl = base64_decode('aHR0cHM6Ly93d3cuYWxpZXhwcmVzcy5jb20vYWVnbG9kZXRhaWx3ZWIvYXBpL2xvZ2lzdGljcy9mcmVpZ2h0P3Byb2R1Y3RJZD0=') . $ss . base64_decode('JmNvdW50PQ==') . $tt . base64_decode('JmNvdW50cnk9') . $pp . base64_decode('JnByb3ZpbmNlQ29kZT0mY2l0eUNvZGU9JnRyYWRlQ3VycmVuY3k9VVNE');
                $pr = $p->get_price();
                if (isset($pr)) {
                    $finalUrl = $finalUrl . base64_decode('Jm1pblByaWNlPQ==') . $pr . base64_decode('Jm1heFByaWNlPQ==') . $pr;
                }
                curl_setopt($curl, CURLOPT_URL, $finalUrl);
                curl_setopt($curl, CURLOPT_HTTPHEADER, array(base64_decode('UmVmZXJlcjogaHR0cHM6Ly93d3d3LmFsaWV4cHJlc3MuY29tL2l0ZW0v') . $ss . base64_decode('Lmh0bWw=')));
                curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
                $o = curl_exec($curl);
                curl_close($curl);
                $jr = json_decode($o);
                $finalShippingList = array();
                if ($jr && $jr->body && $jr->success) {
                    $freightResult = $jr->body->freightResult;
                }
                if (is_null($jr)) {
                    foreach ($rates as $rate_key => $rate) {
                        unset($rates[$rate_key]);
                    }
                } else {
                    if (isset($freightResult)) {
                        $list_ship = array(base64_decode('ZXBhY2tldF9yYXRl'), base64_decode('ZmVkZXhfc2hpcHBpbmc='), base64_decode('YWxpZXhwcmVzc19zdGFuZGFyZF9zaGlwcGluZw=='), base64_decode('ZGhsX3NoaXBwaW5n'), base64_decode('cHJlbXVpbV9zaGlwcGluZw=='), base64_decode('ZW1zX3NoaXBwaW5n'), base64_decode('Y2Fpbmlhb19zaGlwcGluZw=='));
                        foreach ($freightResult as $key => $value) {
                            if (isset($list_ship[$key]) && isset($list_ship[$key]) && $value->company && isset($rates[$list_ship[$key]])) {
                                $companyName = str_replace(base64_decode('QWxpRXhwcmVzcw=='), base64_decode('IA=='), $value->company);
                                $rates[$list_ship[$key]]->label = $companyName . base64_decode('ICAtIERlbGl2ZXJ5IGRhdGUg') . $value->deliveryDate . base64_decode('IA==');
                                $rates[$list_ship[$key]]->cost = $value->freightAmount->value;
                                if ($value->freightAmount->value == 0) {
                                    $rates[$list_ship[$key]]->label = $rates[$list_ship[$key]]->label . base64_decode('IChGcmVlIHNoaXBwaW5nKSA=');
                                }
                            }
                        }
                        for ($i = count($freightResult); $i < count($list_ship); $i++) {
                            unset($rates[$list_ship[$i]]);
                        }
                    } else {
                        foreach ($rates as $rate_key => $rate) {
                            unset($rates[$rate_key]);
                        }
                    }
                }
            } else {
                foreach ($rates as $rate_key => $rate) {
                    if ($rate->method_id == base64_decode('ZW1zX3NoaXBwaW5n')) {
                        unset($rates[$rate_key]);
                    }
                    if ($rate->method_id == base64_decode('Y2Fpbmlhb19zaGlwcGluZw==')) {
                        unset($rates[$rate_key]);
                    }
                    if ($rate->method_id == base64_decode('cHJlbXVpbV9zaGlwcGluZw==')) {
                        unset($rates[$rate_key]);
                    }
                    if ($rate->method_id == base64_decode('ZGhsX3NoaXBwaW5n')) {
                        unset($rates[$rate_key]);
                    }
                    if ($rate->method_id == base64_decode('YWxpZXhwcmVzc19zdGFuZGFyZF9zaGlwcGluZw==')) {
                        unset($rates[$rate_key]);
                    }
                    if ($rate->method_id == base64_decode('ZmVkZXhfc2hpcHBpbmc=')) {
                        unset($rates[$rate_key]);
                    }
                    if ($rate->method_id == base64_decode('ZXBhY2tldF9yYXRl')) {
                        unset($rates[$rate_key]);
                    }
                    if ($rate->method_id == base64_decode('Rmx5dF9TcGVjaWFsX0Vjb25vbXk=')) {
                        unset($rates[$rate_key]);
                    }
                    if ($rate->method_id == base64_decode('U3VuWW91X1NwZWNpYWxfRWNvbm9teQ==')) {
                        unset($rates[$rate_key]);
                    }
                    if ($rate->method_id == base64_decode('WUFOV0VOX1NwZWNpYWxfRWNvbm9teQ==')) {
                        unset($rates[$rate_key]);
                    }
                    if ($rate->method_id == base64_decode('VE9QWU9VX1NwZWNpYWxfRWNvbm9teQ==')) {
                        unset($rates[$rate_key]);
                    }
                }
            }
        }
        return $rates;
    }
}
if (get_option(base64_decode('aXNFbmFibGVBdXRvbWF0aWNVcGRhdGVGb3JBdmFpbGFiaWxpdHk=')) == base64_decode(base64_decode('V1E9PQ==')) || get_option(base64_decode(base64_decode('Wlc1aFlteGxRWFYwYjIxaGRHbGpWWEJrWVhSbGN3PT0='))) == base64_decode(base64_decode('V1E9PQ=='))) {
    if (!wp_next_scheduled(base64_decode(base64_decode('ZDI5dmMyaGhjbXN0WVhWMGJ5MTFjR1JoZEdVPQ==')))) {
        wp_schedule_event(time(), base64_decode(base64_decode('WkdGcGJIaz0=')), base64_decode(base64_decode('ZDI5dmMyaGhjbXN0WVhWMGJ5MTFjR1JoZEdVPQ==')));
    }
    add_action(base64_decode(base64_decode('ZDI5dmMyaGhjbXN0WVhWMGJ5MTFjR1JoZEdVPQ==')), base64_decode(base64_decode('WVhWMGIxVndaR0YwWlZOMGIyTnJRVzVrVUhKcFkyVT0=')));
    function autoUpdateStockAndPrice()
    {

       

        $setToOutOfStockIfVariationsDoesNotExist = true;
        $syncStock = true;
        $syncSalePrice = true;
        $syncRegularPrice = true;
        $onlyPublishProductWillSync = true;
        $enableAutomaticUpdates = false;
        $applyPriceFormulaAutomaticUpdate = true;
        $isEnableAutoUpdate = get_option(base64_decode('ZW5hYmxlQXV0b21hdGljVXBkYXRlcw=='));
        $isEnableAutomaticUpdateForAvailability = get_option(base64_decode('aXNFbmFibGVBdXRvbWF0aWNVcGRhdGVGb3JBdmFpbGFiaWxpdHk='));
        if (get_option(base64_decode(base64_decode('WVhCd2JIbFFjbWxqWlVadmNtMTFiR0ZCZFhSdmJXRjBhV05WY0dSaGRHVT0='))) == base64_decode(base64_decode('V1E9PQ=='))) {
            $applyPriceFormulaAutomaticUpdate = true;
        } else {
            $applyPriceFormulaAutomaticUpdate = false;
        }

        // $charmPri00 = false;



        if (get_option(base64_decode(base64_decode('YzNsdVkxTjBiMk5y'))) == base64_decode(base64_decode('V1E9PQ=='))) {
            $syncStock = true;
        } else {
            $syncStock = false;
        }
        if (get_option(base64_decode(base64_decode('YzNsdVkxTmhiR1ZRY21salpRPT0='))) == base64_decode(base64_decode('V1E9PQ=='))) {
            $syncSalePrice = true;
        } else {
            $syncSalePrice = false;
        }
        if (get_option(base64_decode(base64_decode('YzNsdVkxSmxaM1ZzWVhKUWNtbGpaUT09'))) == base64_decode(base64_decode('V1E9PQ=='))) {
            $syncRegularPrice = true;
        } else {
            $syncRegularPrice = false;
        }
        $productToBeLoaded = array(base64_decode('cHVibGlzaA=='), base64_decode('ZHJhZnQ='));
        $priceFormulaIntervalls = get_option(base64_decode(base64_decode('Y0hKcFkyVkdiM0p0ZFd4aFNXNTBaWEoyWVd4c2N3PT0=')));
        $args = array(base64_decode(base64_decode('Y0c5emRGOTBlWEJs')) => base64_decode(base64_decode('Y0hKdlpIVmpkQT09')), base64_decode(base64_decode('Y0c5emRITmZjR1Z5WDNCaFoyVT0=')) => -1, base64_decode(base64_decode('Y0c5emRGOXpkR0YwZFhNPQ==')) => $productToBeLoaded, base64_decode(base64_decode('YldWMFlWOXhkV1Z5ZVE9PQ==')) => array(array(base64_decode(base64_decode('YTJWNQ==')) => base64_decode(base64_decode('Y0hKdlpIVmpkRlZ5YkE9PQ==')), base64_decode(base64_decode('ZG1Gc2RXVT0=')) => base64_decode(base64_decode('WVd4cFpYaHdjbVZ6Y3k1amIyMHZhWFJsYlE9PQ==')), base64_decode(base64_decode('WTI5dGNHRnlaUT09')) => base64_decode(base64_decode('VEVsTFJRPT0=')))));
        $products = new WP_Query($args);
        $finalList = array();
        if ($products->have_posts()) {
            while ($products->have_posts()) : $products->the_post();
                $theid = get_the_ID();
                $product = wc_get_product($theid);
                $sku = $product->get_sku();
                $post_id = $theid;
                if ($product->is_type(base64_decode('dmFyaWFibGU='))) {
                    $productUrl = get_post_meta($theid, base64_decode(base64_decode('Y0hKdlpIVmpkRlZ5YkE9PQ==')), true);
                    $curl = curl_init();
                    curl_setopt($curl, CURLOPT_URL, $productUrl);
                    curl_setopt($curl, CURLOPT_CUSTOMREQUEST, base64_decode(base64_decode('UjBWVQ==')));
                    curl_setopt($curl, CURLOPT_FOLLOWLOCATION, TRUE);
                    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
                    $output = curl_exec($curl);
                    curl_close($curl);
                    if (strpos($output, base64_decode(base64_decode('VUdGblpTQk9iM1FnUm05MWJtUT0='))) == true && $isEnableAutomaticUpdateForAvailability == base64_decode('WQ==')) {
                        if (isset($post_id)) {
                            update_post_meta($post_id, base64_decode('bGFzdFVwZGF0ZWQ='), base64_decode('cHJvZHVjdCBpcyBvdXQgb2Ygc3RvY2s='));
                            $result = update_post_meta($post_id, base64_decode(base64_decode('YVhORmVIQnBjbVZr')), base64_decode(base64_decode('ZEhKMVpRPT0=')));
                            $post = array(base64_decode(base64_decode('U1VRPQ==')) => $post_id, base64_decode(base64_decode('Y0c5emRGOXpkR0YwZFhNPQ==')) => base64_decode(base64_decode('WkhKaFpuUT0=')));
                            wp_update_post($post);
                        }
                    } else if (strpos($output, base64_decode(base64_decode('YzJ0MVRXOWtkV3hs'))) == true && $isEnableAutoUpdate == base64_decode('WQ==')) {
                        $regSku = base64_decode('LyJza3VBdHRyIjouKn19XS9pbQ==');
                        if (preg_match($regSku, $output, $matches)) {
                            if (isset($matches) && isset($matches[0])) {
                                $skuList = json_decode(base64_decode('W3s=') . $matches[0], true);
                                if (isset($skuList) && count($skuList) > 0) {
                                    update_post_meta($post_id, base64_decode('bGFzdFVwZGF0ZWQ='), date(base64_decode('WS1tLWQgSDppOnM=')));
                                    $productWC = wc_get_product($post_id);
                                    $oldvariations = $productWC->get_available_variations();
                                    if (isset($oldvariations) && count($oldvariations) > 0) {
                                        foreach ($oldvariations as $oldV) {
                                            $variationId = $oldV[base64_decode(base64_decode('ZG1GeWFXRjBhVzl1WDJsaw=='))];
                                            $isVariationExist = false;
                                            if (isset($variationId)) {
                                                foreach ($skuList as $singleSkuObject) {
                                                    if ($singleSkuObject[base64_decode(base64_decode('YzJ0MVNXUT0='))] == $oldV[base64_decode(base64_decode('YzJ0MQ=='))]) {
                                                        $isVariationExist = true;
                                                        $skuVal = $singleSkuObject[base64_decode(base64_decode('YzJ0MVZtRnM='))];
                                                        $salePrice = $skuVal[base64_decode(base64_decode('WVdOMFUydDFRMkZzVUhKcFkyVT0='))];
                                                        $regularPrice = $skuVal[base64_decode(base64_decode('YzJ0MVEyRnNVSEpwWTJVPQ=='))];
                                                        $availQuantity = $skuVal[base64_decode(base64_decode('WVhaaGFXeFJkV0Z1ZEdsMGVRPT0='))];
                                                        if (isset($salePrice) && $syncSalePrice == true) {
                                                            if ($applyPriceFormulaAutomaticUpdate == true) {
                                                                $result = applyFormula($salePrice, $priceFormulaIntervalls);
                                                            } else {
                                                                $result = $salePrice;
                                                            }
                                                            update_post_meta($variationId, base64_decode(base64_decode('WDNOaGJHVmZjSEpwWTJVPQ==')), $result);
                                                        }
                                                        if (isset($regularPrice) && $syncRegularPrice == true) {
                                                            $result = applyFormula($regularPrice, $priceFormulaIntervalls);
                                                            if ($applyPriceFormulaAutomaticUpdate == true) {
                                                                $result = applyFormula($regularPrice, $priceFormulaIntervalls);
                                                            } else {
                                                                $result = $regularPrice;
                                                            }
                                                            update_post_meta($variationId, base64_decode(base64_decode('WDNCeWFXTmw=')), $result);
                                                            update_post_meta($variationId, base64_decode(base64_decode('WDNKbFozVnNZWEpmY0hKcFkyVT0=')), $result);
                                                            wc_delete_product_transients($variationId);
                                                        }
                                                        if (isset($availQuantity) && $availQuantity > -1 && $syncStock == true) {
                                                            update_post_meta($variationId, base64_decode(base64_decode('WDIxaGJtRm5aVjl6ZEc5amF3PT0=')), base64_decode(base64_decode('ZVdWeg==')));
                                                            update_post_meta($variationId, base64_decode(base64_decode('WDNOMGIyTnI=')), $availQuantity);
                                                        }
                                                    }
                                                }
                                                if ($isVariationExist == false) {
                                                    if ($setToOutOfStockIfVariationsDoesNotExist == true && $syncStock == true) {
                                                        update_post_meta($variationId, base64_decode(base64_decode('WDIxaGJtRm5aVjl6ZEc5amF3PT0=')), base64_decode(base64_decode('ZVdWeg==')));
                                                        update_post_meta($variationId, base64_decode(base64_decode('WDNOMGIyTnI=')), base64_decode(base64_decode('TUE9PQ==')));
                                                    }
                                                } else { }
                                            }
                                        }
                                    }
                                } else {
                                    update_post_meta($post_id, base64_decode('bGFzdFVwZGF0ZWQ='), base64_decode('IC0gKyAtIHNrdUxpc3QgY291bnQgMA==') . $matches[0]);
                                }
                            } else {
                                update_post_meta($post_id, base64_decode('bGFzdFVwZGF0ZWQ='), base64_decode('bWF0Y2hpbmcgaXNzdWU='));
                            }
                        } else {
                            update_post_meta($post_id, base64_decode('bGFzdFVwZGF0ZWQ='), base64_decode('Y2Fubm90IG1hdGNoIHByb2R1Y3QgcmVn'));
                        }
                    } else if (strpos($output, base64_decode('Y2xhc3M9ImltZ0NhcHRjaGEi')) == true) {
                        update_post_meta($post_id, base64_decode('bGFzdFVwZGF0ZWQ='), base64_decode('Y2Fubm90IGdldCBkZXRhaWxzIG9mIHRoZSBuZXcgcHJvZHVjdCBwbGVhc2UgdmVyaWZ5IHRoaXMgYWxpZXhwcmVzcyBwYWdl') . $output);
                        break;
                    } else {
                        update_post_meta($post_id, base64_decode('bGFzdFVwZGF0ZWQ='), base64_decode('Y2Fubm90IGdldCBkZXRhaWxzIG9mIHRoZSBuZXcgcHJvZHVjdCBleGNlcHRpb24='));
                    }
                } else {
                    update_post_meta($post_id, base64_decode('bGFzdFVwZGF0ZWQ='), date(base64_decode('WS1tLWQgSDppOnM=')));
                }
                sleep(4);
            endwhile;
        } else {
            echo __(base64_decode(base64_decode('VG04Z2NISnZaSFZqZEhNZ1ptOTFibVE9')));
        }
    }
} else {
    wp_clear_scheduled_hook(base64_decode(base64_decode('ZDI5dmMyaGhjbXN0WVhWMGJ5MTFjR1JoZEdVPQ==')));
}
function applyFormula($originalPrice, $formulaIntervalls)
{

    if (strpos($originalPrice, ',') !== false) {
        $originalPrice =  str_replace(',','',$originalPrice);
    }

    $charmPri99 = false;
    // $charmPri00 = false;
    

    if (get_option('charmPri99') == base64_decode(base64_decode('V1E9PQ=='))) {
        $charmPri99 = true;
    } else {
        $charmPri99 = false;
    }


    // if (get_option('charmPri00') == base64_decode(base64_decode('V1E9PQ=='))) {
    //     $charmPri00 = true;
    // } else {
    //     $charmPri00 = false;
    // }



    $newPrice = $originalPrice;
    if (isset($formulaIntervalls) && count($formulaIntervalls)) {
        foreach ($formulaIntervalls as $formula) {
            $min = $formula[base64_decode(base64_decode('YldsdQ=='))];
            $max = $formula[base64_decode(base64_decode('YldGNA=='))];
            $percentageMultiply = $formula[base64_decode(base64_decode('YlhWc2RHbHdiSGs9'))];
            $addition = $formula[base64_decode(base64_decode('WVdSa2FYUnBiMjQ9'))];
            if (!isset($addition)) {
                $addition = 0;
            }
            if ($originalPrice > $min && $originalPrice < $max && $percentageMultiply > 0) {
                if ($percentageMultiply) {
                    $newPrice = $originalPrice + (($originalPrice * $percentageMultiply) / 100) + $addition;
                }
            }
        }
    }

    if($charmPri99 == true){
        $newPrice = rounder($newPrice);
    }
    // if($charmPri00 == true){
    //     $newPrice = number_format(round($newPrice, 2), 2);
    // }


    return $newPrice;
}

function rounder($num){
    $fln= $num-floor($num);
    if ($fln>0 and $fln<0.5) $fln=0.49;
    else $fln=0.99;

    return floor($num)+$fln;
}


add_filter(base64_decode('d29vY29tbWVyY2VfcHJvZHVjdF90YWJz'), "woo_rename_tabs_aliexpress_plugin", 98);
function woo_rename_tabs_aliexpress_plugin($tabs)
{
    global $product;
    if (get_comments_number($product->get_id()) == 1 && get_comments_number($product->get_id()) > 0) {
        $tabs[base64_decode('cmV2aWV3cw==')][base64_decode('dGl0bGU=')] = __(base64_decode('UmV2aWV3ICgg') . get_comments_number($product->get_id()) . base64_decode('ICk='));
    } else {
        $tabs[base64_decode('cmV2aWV3cw==')][base64_decode('dGl0bGU=')] = __(base64_decode('UmV2aWV3cyAoIA==') . get_comments_number($product->get_id()) . base64_decode('ICk='));
    }
    return $tabs;
}

add_filter(base64_decode('d29vY29tbWVyY2VfbG9jYXRlX3RlbXBsYXRl'), "intercept_wc_template_aliexpress_plugin", 10, 3);
/**
 * Filter the cart template path to use cart.php in this plugin instead of the one in WooCommerce.
 *
 * @param string $template      Default template file path.
 * @param string $template_name Template file slug.
 * @param string $template_path Template file name.
 *
 * @return string The new Template file path.
 */ function intercept_wc_template_aliexpress_plugin($template, $template_name, $template_path)
{
    if (base64_decode('cmF0aW5nLnBocA==') === basename($template)) {
        $template = trailingslashit(plugin_dir_path(__FILE__)) . base64_decode('d29vY29tbWVyY2Uvc2luZ2xlLXByb2R1Y3QvcmF0aW5nLnBocA==');
    }
    return $template;
}
